/** $lic$
 * Copyright (C) 2015-2016 by Massachusetts Institute of Technology
 *
 * This file is part of Whirltool.
 *
 * Whirltool is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * If you use this software in your research, we request that you reference
 * the Whirlpool paper ("Whirlpool: Improving Dynamic Cache Management with Static Data
 * Classification", Mukkara, Beckmann and Sanchez, ASPLOS-21, April 2016) as the
 * source in any publications that use this software, and that you send us a
 * citation of your work.
 *
 * Whirltool is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Whirltool.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/
#define UNW_LOCAL_ONLY
#include <stdio.h>
#include <stdlib.h>
#include <libunwind.h>

void *buf[10];
int n;

__attribute__((always_inline)) inline void show_backtrace (void) {
 n = unw_backtrace(buf, 3);

 int i;

 for (i = 0; i < n; i++){
    printf("%d %lx \n", i, (uint64_t)buf[i]);
 }

}

/* A dummy function to make the backtrace more interesting. */
inline void dummy_function5 (void)
{
  show_backtrace();
}

inline void dummy_function4 (void)
{
  dummy_function5();
}

inline void dummy_function3 (void)
{
  dummy_function4();
}

inline void dummy_function2 (void)
{
  dummy_function3();
}

inline void dummy_function1 (void)
{
  dummy_function2();
}


int
main (void)
{
  int i;
  dummy_function1();
  return 0;
}
